CREATE TABLE mw_blogs (
  id            INT UNSIGNED NOT NULL auto_increment,
  title         TEXT NOT NULL,
  comments      TEXT NOT NULL,
  addDate       DATE NOT NULL default '0000-00-00',
  postdate      TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
  rawpostdate   VARCHAR(50) NOT NULL default '',
  allow         ENUM('0','1') NOT NULL DEFAULT '1',
  notify        ENUM('0','1') NOT NULL DEFAULT '1',
  v_count       INT(5) NOT NULL default '0',
  archiveMonth  CHAR(2) NOT NULL default '',
  archiveYear   CHAR(4) NOT NULL default '',
  rss_date      VARCHAR(35) NOT NULL default '',
PRIMARY KEY(id)) TYPE=MyISAM;

CREATE TABLE mw_comments (
  id           INT UNSIGNED NOT NULL auto_increment,
  postid       INT UNSIGNED NOT NULL default '0',
  name         VARCHAR(50) NOT NULL default '',
  email        VARCHAR(250) NOT NULL default '',
  comments     TEXT NOT NULL,
  rawpostdate  VARCHAR(50) NOT NULL default '',
  addDate      DATE NOT NULL default '0000-00-00',
  postdate     TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
  adminPost    ENUM('0','1') NOT NULL DEFAULT '1',
PRIMARY KEY(id)) TYPE=MyISAM;

CREATE TABLE mw_settings (
  id             TINYINT(1) NOT NULL default '1',
  theme          VARCHAR(50) NOT NULL default 'standard',
  name           VARCHAR(50) NOT NULL default '',
  email          VARCHAR(60) NOT NULL default '',
  website        VARCHAR(100) NOT NULL default '',
  w_path         VARCHAR(250) NOT NULL default '',
  blogname       VARCHAR(200) NOT NULL default '',
  dateformat     VARCHAR(20) NOT NULL default 'D j M Y, G:ia',
  timeOffset     VARCHAR (4) NOT NULL default '',
  language       VARCHAR(30) NOT NULL default 'english.php',
  total          INT(3) NOT NULL default '25',
  hometotal      INT(3) NOT NULL default '5',
  rssfeeds       INT(5) NOT NULL default '50',
  totalArchives  TINYINT(3) NOT NULL default '18',
  commentsOrder  CHAR(3) NOT NULL default 'asc',
  enableCaptcha  ENUM('0','1') NOT NULL DEFAULT '1',
  modR           ENUM('0','1') NOT NULL DEFAULT '0',
  parseLinks     ENUM('0','1') NOT NULL DEFAULT '1',
  meta_k         MEDIUMTEXT NOT NULL,
  meta_d         MEDIUMTEXT NOT NULL,
  bookmarks      VARCHAR(50) NOT NULL default '',
  profile        MEDIUMTEXT NOT NULL,
  profileImage   VARCHAR(50) NOT NULL default '',
  profileUpdate  TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
  imageWidth     TINYINT(3) NOT NULL default '90',
  imageHeight    TINYINT(3) NOT NULL default '120',
  adsense        TEXT NOT NULL,
  snap           TEXT NOT NULL,
  wysiwyg        ENUM('0','1') NOT NULL DEFAULT '1',
  smtp           ENUM('0','1') NOT NULL DEFAULT '0',
  smtp_host      VARCHAR(100) NOT NULL default 'localhost',
  smtp_user      VARCHAR(100) NOT NULL default '',
  smtp_pass      VARCHAR(100) NOT NULL default '',
  smtp_port      VARCHAR(5) NOT NULL default '25',
PRIMARY KEY(id)) TYPE=MyISAM;

INSERT INTO mw_settings (id,theme,name,email,website,w_path,blogname,dateformat,timeOffset,language,total,
                         hometotal,rssfeeds,totalArchives,commentsOrder,enableCaptcha,modR,parseLinks,meta_k,
                         meta_d,bookmarks,profile,profileImage,profileUpdate,imageWidth,imageHeight,adsense,snap,wysiwyg,
                         smtp,smtp_host,smtp_user,smtp_pass,smtp_port
                         ) VALUES (
                         1,'standard','Your Name or Username','you@yoursite.com','Website Name',
                         'http://www.yoursite.com/weblog','Your Blog Name','D j M Y, G:ia','0','english.php',25,5,
                         50,15,'asc','1','0','1','','','1,2,6,13,15','','',now(),90,120,'','','1','0','localhost','','','25');

CREATE TABLE mw_favourites (
  id           INT(4) NOT NULL auto_increment,
  name         VARCHAR(100) NOT NULL default '',
  url          TEXT NOT NULL,
PRIMARY KEY(id)) TYPE=MyISAM;
